reddit 0.4.0+1

  • README.md
  • CHANGELOG.md
  • Installing
  • Versions
  • 74

dart-reddit

A Reddit library for Dart, inspired by reddit.js (API) and raw.js (Auth).

Documentation

See the Dart documentation.

Usage

Add the following to your pubspec.yaml:

dependencies:
  reddit: any

Creating a client

The top class Reddit takes a Client as parameter. This client can be constructed using thehttp package.

// in Dart VM
Reddit reddit = new Reddit(new Client());
// in browser
Reddit reddit = new Reddit(new BrowserClient());

OAuth

To enable OAuth, you will need an app identifier and a secret. Get them here.

OAuth is required for some of the public endpoints (those marked OAuth-only) and will be required for all endpoints starting August 3, 2015 (see this announcement).

There are two options: App-only and User authorization.

  • App-only auth
reddit.authSetup(identifier, secret);
// with user info
await reddit.authFinish(username: "sroose", password: "correct horse battery staple");
// or without
await reddit.authFinish();

Note that not providing (developer) user info will result in getting 503 Service Unavailable responses after a while.

  • User-enabled auth
reddit.authSetup(identifier, secret);
Uri authUrl = reddit.authUrl("https://myapp.com/auth_redirect");
// redirect user to authUrl and gather the response from the auth server
await reddit.authFinish(response: authServerResponse);
// or if you already extracted the auth code from the response
await reddit.authFinish(code: authCode);

Queries, filters and listings

Most methods in the API construct a Query, which can be fetched to get a future with the results.

Most queries allow filtering. For the supported filters, we refer to the Reddit API docs or the documentation for this library.

// without filters
reddit.frontPage.newPosts().fetch().then(print);
// filtered
reddit.frontPage.hot().limit(10).fetch().then(print);

A lot of queries also are listings. Listings allow for browsing through content across multiple queries.

// using the regular fetch() method (not recommended)
reddit.sub("dartlang").top("day").fetch().then((result) {
  print(result);
  if (notEnough) {
    result.fetchMore().then((result) {
      print(result);
      if (stillNotEnough) {
        result.fetchmore().then(print);
      }
    });
  }
});

// or using the dart:async API
reddit.sub("dartlang").top("month").listen((result) {
  print(result);
  if (notEnough) {
    result.fetchMore();
  }
})

Browsing Reddit

You can use the standard read-only API to browse Reddit.

// the front page
reddit.front.hot().fetch().then(print);
// or subreddits
reddit.sub("dartlang").hot().fetch().then(print);

Some examples using filters:

reddit.sub("dartlang").top().t("day").limit(10).fetch().then(print);

Comments

Fetching comments for a link:

reddit.sub("dartlang").comments("2ek93l").depth(3).fetch().then(print);

Or a single comment:

reddit.sub("dartlang").comments("2ek93l").comment("ck0mkcy").context(2).fetch().then(print);

Search through reddit:

reddit.sub("dartlang").search("reddit api").limit(5).sort("hot").fetch().then(print);

Subreddits

Find subreddits:

reddit.newSubreddits().fetch().then(print);

reddit.popularSubreddits().fetch().then(print);

reddit.recommendedSubreddits(["dartlang", "reddit"]).fetch().then(print);

reddit.subredditsByTopic("programming").fetch().then(print);

Get information about a subreddit:

reddit.sub("dartlang").about().fetch().then(print);

Users

Get information about a user:

reddit.user("sroose").about().fetch().then(print);

Get listings from users:

reddit.user("sroose").comments("month").listen(print);

reddit.user("sroose").submitted("week").sort("hot").listen(print);

Get a list of multi's from a user:

reddit.user("sroose").multis().fetch().then(print);

Changelog

0.4.0 (2017-01-22)

  • Fix subreddit.search() to restrict results to the subreddit

0.3.3 (2015-12-18)

  • Upgraded dependencies to latest versions
  • Adapted to breaking changes in oauth2 v1.0.0
  • Added better support for multireddits

0.3.2 (2015-04-03)

  • Updated RedditUri with official regex and extra test
  • Updated README
  • Constant constructor for Fullname
  • Improved exception handling in Query

0.3.1 (2015-04-02)

  • Added FullnameType enum
  • Added Fullname.id and Fullname.type getters
  • Bugfix in FilterableQuery.filter

0.3.0 (2015-04-01)

  • Added full OAuth2 support (app-only and user)
  • Changed auth interface
  • Expose RedditUri and Fullname classes

0.2.0 (2015-04-01)

  • Added App-only OAuth support, inspired by raw.js

0.1.0 (2015-03-31)

  • Initial version, inspired by reddit.js

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  reddit: "^0.4.0+1"

2. Install it

You can install packages from the command line:

with pub:


$ pub get

Alternatively, your editor might support pub get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:reddit/reddit.dart';
        
Version Uploaded Documentation Archive
0.4.0+1 Mar 15, 2018 Go to the documentation of reddit 0.4.0+1 Download reddit 0.4.0+1 archive
0.4.0 Jan 22, 2017 Go to the documentation of reddit 0.4.0 Download reddit 0.4.0 archive
0.3.3 Dec 18, 2015 Go to the documentation of reddit 0.3.3 Download reddit 0.3.3 archive
0.3.2 May 14, 2015 Go to the documentation of reddit 0.3.2 Download reddit 0.3.2 archive
0.3.1 Apr 1, 2015 Go to the documentation of reddit 0.3.1 Download reddit 0.3.1 archive
0.3.0 Apr 1, 2015 Go to the documentation of reddit 0.3.0 Download reddit 0.3.0 archive
0.2.0 Apr 1, 2015 Go to the documentation of reddit 0.2.0 Download reddit 0.2.0 archive
0.1.0+1 Mar 31, 2015 Go to the documentation of reddit 0.1.0+1 Download reddit 0.1.0+1 archive
0.1.0 Mar 31, 2015 Go to the documentation of reddit 0.1.0 Download reddit 0.1.0 archive

Analysis

We analyzed this package on Apr 23, 2018, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.0.0-dev.49.0
  • pana: 0.10.6

Scores

Popularity:
Describes how popular the package is relative to other packages. [more]
49 / 100
Health:
Code health derived from static analysis. [more]
100 / 100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
100 / 100
Overall score:
Weighted score of the above. [more]
74
Learn more about scoring.

Platforms

Detected platforms: web, other

Primary library: package:reddit/reddit.dart with components: mirrors.

Suggestions

  • The description is too short.

    Add more detail about the package, what it does and what is its target use case. Try to write at least 60 characters.

  • Package is pre-v1 release.

    While there is nothing inherently wrong with versions of 0.*.*, it usually means that the author is still experimenting with the general direction API.

  • Maintain an example.

    Create a short demo in the example/ directory to show how to use this package. Common file name patterns include: main.dart, example.dart or you could also use reddit.dart.

  • Fix analysis and formatting issues.

    Analysis or formatting checks reported 1 hint.

    Strong-mode analysis of lib/src/query.dart gave the following hint:

    line: 46 col: 2
    'proxy' is deprecated and shouldn't be used.

Dependencies

Package Constraint Resolved Available
Direct dependencies
http >=0.11.1+3 <0.12.0 0.11.3+16
json_object >=1.0.19 <2.0.0 1.0.19+1
logging >=0.11.0 <0.12.0 0.11.3+1
oauth2 >=1.0.1 <2.0.0 1.2.0
Transitive dependencies
async 2.0.6
charcode 1.1.1
collection 1.14.9
http_parser 3.1.1
path 1.5.1
source_span 1.4.0
string_scanner 1.0.2
typed_data 1.1.5
Dev dependencies
unittest any